--require 'love.thread'
require 'love.timer'
require 'love.image'
require 'love.filesystem'

require 'TSerial'
require 'complex'
require 'sphere'

Size = 200
MAXITER = 256*3


im = love.image
tm = love.timer
tr = love.thread


mx1=-1 mx2=1 my1=-1 my2=1


tabColor={}


function buildColorsTab()
  local v,x,r,g,b,a,c,cn,F F = 5
  a=255
  for x=0,MAXITER do
    v = x/MAXITER -- v->0..1
    r = 128 + 127 * math.sin(3*math.pi/2 + 2*math.pi*F * v)
    g = 128 + 127 * math.sin(2*math.pi/2 + 2*math.pi*F * v)
    b = 128 + 127 * math.sin(1*math.pi/2 + 2*math.pi*F * v)
    tabColor[x]={r,g,b,a}
  end
  --tabColor[MAXITER]={0,0,0,0}
end


function buildColorsTab1()
  local x,r,g,b,a,c,cn
  a=255
  for x=0,MAXITER do
    r=0 g=0 b= 0
    
    if x < 256 then b = x 
    elseif x < 512 then b=255 g = x -256 
    elseif x < 768 then b=255 g=255 r = x - 512
    else b=255 g=255 r = 255   end
    
--    if x < 256 then r = x 
--    elseif x < 512 then r=255 g = x -256 
--    elseif x < 768 then r=255 g=255 b = x - 512
--    else b=255 g=255 r = 255   end
    
    
    tabColor[x]={r,g,b,a}
  end
  --tabColor[MAXITER]={0,0,0,0}
end


function fillGreen(x,y,r,g,b,a)
--function fillRed(x,y,r,g,b,a)
  r = 0 g = 200 b = 0 a = 100
  return r,g,b,a
end

function setSize(Size)
  imageD = im.newImageData(Size,Size)
  imageD:mapPixel(fillGreen)
  tr:set('id2rK',imageD) -- pass reference
end

buildColorsTab()


C2tab={}  
C2max = 0

--function f2(v)  
--  if v > MAXITER then v=MAXITER return end
--  if C2max < v then C2max = v end
--  if C2tab[v]==nil then
--    C2tab[v]= 1
--  else 
--    C2tab[v] = C2tab[v] + 1
--  end
--end


tr	= love.thread.getThread()

setSize(Size)

Pts={}
Idx = 1


local Z , C
local cx

function f1a(zr,zi,cr,ci) -- z = z^2+c
    z = complex.new(zr,zi)
    c = complex.new(cr,ci)
    z = complex.mul(z,z)
    z = complex.add(z,c)
    return z
end

--[[
function complex.add (c1, c2)
  return complex.new(c1.r + c2.r, c1.i + c2.i)
end
function complex.mul (c1, c2)
  return complex.new(c1.r*c2.r - c1.i*c2.i,
                     c1.r*c2.i + c1.i*c2.r)
end
]]

function f1(r,i)
    local n,dist,z
    C = complex.new(r,i)
    Z = complex.new(0,0)
    z = complex.new(0,0)
    dist = 0
    n = 0
    while dist < 4 and n < MAXITER do
      z.r = Z.r*Z.r - Z.i*Z.i 
      z.i = Z.r*Z.i + Z.r*Z.i 
      Z.r = z.r + C.r
      Z.i = z.i + C.i
      dist = Z.r*Z.r + Z.i*Z.i -- appartiene a mandelbrot se dist^2 < escapeValue(suppose 4)
      n = n+1
    end
    
    --[[  --http://linas.org/art-gallery/escape/escape.html
      Z = Z*Z +C; iter_count ++;    // a couple of extra iterations helps
      Z = Z*Z +C; iter_count ++;    // decrease the size of the error term.
      float modulus = sqrt (ReZ*ReZ + ImZ*ImZ);
      float mu = iter_count - (log (log (modulus)))/ log (2.0);
      color_value = colormap_lookup (mu);
      draw_pixel (C, color_value);    
      -----------------------------------------------------
      z = z * z + C; iteration++;
      z = z * z + C; iteration++;
      double mu = iteration - (Math.Log(Math.Log(z.Modulus))) / logEscapeRadius;
      colorIndex = (int)(mu / maxIteration * 768);
      if (colorIndex >= 768) colorIndex = 0;
      if (colorIndex < 0) colorIndex = 0;
    ]]    
    
--    cx = complex.mul(z,z) cx = complex.add(cx,c)  z = cx  
--    cx = complex.mul(z,z) cx = complex.add(cx,c)  z = cx
--    n=n+2
--    modulus = math.sqrt(z.r*z.r+z.i*z.i)
--    local mu = n - (math.log (math.log(modulus)))/(math.log(2))
--    n1 = math.floor(mu)
--    if n1 < 0 then n1=0 end
--    if n1 > MAXITER then n1 = MAXITER end
    
    return n 
    
end




redo = false

while true do
  
  
  if tr:get('c2') or redo then
    
    tr:set('id2r',imageD) -- pass reference
    
    tm1 = love.timer.getMicroTime()
    
    local dxr,dyr,n2,x,y,iw,ih
    local r,g,b,a,c,v
    local r,i
    local idx
    
    n2 = 1
    tr:set('nn2',n2)
    
    mx1 = tr:get('mx1',mx1)    mx2 = tr:get('mx2',mx2) 
    my1 = tr:get('my1',my1)    my2 = tr:get('my2',my2) 
    
    dxr = math.abs(mx1 - mx2)
    dyr = math.abs(my1 - my2)
    
    iw = imageD:getWidth()  
    ih = imageD:getHeight() 
    
    Pts[1]=iw
    Pts[2]=ih
    Idx = 3
    
    for i=0,MAXITER do C2tab[i] = 0 end
    
    
    for y=0,ih-1,1 do
      
        for x =0,iw-1,1 do
        
       
        
          r = (x * dxr / iw) + mx1
          i = (y * dyr / ih) + my1
          
          v = f1(r,i)
          
          
          --Pts[Idx]=v  Idx=Idx+1
          
          if(v <= MAXITER) then  C2tab[v] = C2tab[v]+1 -- don't update at MAXITER
          
          r=tabColor[v][1] g=tabColor[v][2] b=tabColor[v][3] a=tabColor[v][4]
  
          imageD:setPixel(x,y,r,g,b,a)
          
          n2 = n2+1
          if (n2 % 100)==0 then
            tr:set('nn2',n2)
            tr:set('id2rK',imageD)
          end
          
        end
        
      end
      
--      if tr:peek('c2') then
--        redo = true
--        break
--      end
  
      if tr:get('stop') then
        break
      end
      
    end
    
    if tr:get('c2') then -- clear
      mx1 = tr:get('mx1',mx1)    mx2 = tr:get('mx2',mx2) 
      my1 = tr:get('my1',my1)    my2 = tr:get('my2',my2) 
    end
    
    
    dt1 = love.timer.getMicroTime() - tm1
    
    local str = TSerial.pack(C2tab)
    tr:set('C2tabStr',str)


    tr:set('id2r',imageD)
    tr:set('done2',true)
    
  end
  
  if tr:get('saveData') then
    print("saving data...")
    local str1 = "IMG_"..os.time()..".png"
    imageD:encode(str1)
    print("saved.")
  end  
  
  if tr:get('size1') then Size = 100 setSize(Size) end  
  if tr:get('size2') then Size = 200 setSize(Size) end  
  if tr:get('size3') then Size = 300 setSize(Size) end  
  if tr:get('size4') then Size = 400 setSize(Size) end  
  if tr:get('size5') then Size = 500 setSize(Size) end  
  if tr:get('size6') then Size = 600 setSize(Size) end  
  
  
  
  ----------------------------------------------------
  
--  ----------------------------------------------------
--  if tr:get('c3') then
--    print("".."mx1="..mx1.."\r\nmx2="..mx2.."\r\nmy1="..my1.."\r\nmy2="..my2.."\r\n")
--  end
--  ----------------------------------------------------
  
  
end

    