--require 'Thread2'
require "TSerial"
require "complex"
require 'sphere'
function love.load()
 
  if arg[#arg] == "-debug" then require("mobdebug").start() end
  
  drawHelpFlag  = true
  
  
  Par={}
  if love.filesystem.exists("par.txt")==false then
    Par[1] = 1 -- 
    Par[2] = 2 -- 
    local str1 = TSerial.pack(Par)
    love.filesystem.write("par.txt",str1)
  else
    local str1 = love.filesystem.read("par.txt")
    Par=TSerial.unpack(str1)
  end
  
  MbGlobals()    
  
  buildColorsTab()
    
  Clean = true
  
  gr = love.graphics
  im = love.image
  tm = love.timer
  
  
  toggleMe = false
  imageMeD=im.newImageData('me.png')
  imageMeG=gr.newImage(imageMeD)
  
  
  setButton(16,1,20,4,1,'full')    
  
  Msx1=0 Msy1=0  Msx2=0 Msy2=0 MShow=true
  
  lastDrawTime = 0
  drawTime = 0
  
--  fontg1 = love.graphics.newImageFont("disegno.png","0123456789!")
--  fontg = love.graphics.newImageFont("imagefont2.png",
--    " abcdefghijklmnopqrstuvwxyz" ..
--    "ABCDEFGHIJKLMNOPQRSTUVWXYZ0" ..
--    "123456789.,!?-+/():;%&`'*#=[]\"")
--  font13 = love.graphics.newFont("Courier New.ttf",13)
--  font14 = love.graphics.newFont("Courier New Bold.ttf",14)
--  font16 = love.graphics.newFont("Courier New Bold.ttf",16)
--  font18 = love.graphics.newFont("consola.ttf",18)
  
  
  sw,sh,fs,vsync,fsaa = gr.getMode()
  -- vsync = false  fsaa = 1
  -- sw = 1280 sh = 1024
  gr.setMode(sw,sh,fs,vsync,fsaa)

  t1 = 0 t2 = 0
  x1 = 0
  x2 = 0 x2v = 0  rdy = "idle"
  x3=0 x4=0 x5=0
  tt1 = 0
  tt2 = 0
  
  vnn=0 ct=0 ni=0
  vnn2 = 0
  
  tr = love.thread.newThread('threadN1','thread1.lua')
  tr:start()
  
  tr2 = love.thread.newThread('threadN2','Thread2.lua')
  tr2:start()
    
  keepTAP(KFirst)
  
  -------------------------------------
  -- mandelbrot related images 
  -- (data:imgaD2  graphics:imageG2)
  -------------------------------------
  imageD2 = im.newImageData(100,100)  newPositionImageD2()
  imageD2:mapPixel(fillRed)
  imageG2 = gr.newImage(imageD2) 
  C2TabImageD = im.newImageData(MAXITER,100)
  imageTabG = gr.newImage(C2TabImageD)
  -------------------------------------
  
  
  imageD = im.newImageData(100,100)
  imageD:mapPixel(mapPixel_fillGreen)
  imageG = gr.newImage(imageD)
  
  
  d3r = 0 -- used for rotation
  SpeedInc = 0.01
  
  
  rdy = "idle..."
  --tr:set('c3',true)  -- build imageD inthread 
  --tr:set('c2',true)  -- keep imageD reference in thread
  
  
  love.keyboard.setKeyRepeat(0.1,0.01)
  
  
  imageSG = gr.newImage(imageSD)  
  
  doMandel()
  
end

function love.update(dt)
  
  x3 = x3 + dt
  x5 = x5 + 1
  
  t1 = t1 + dt
  if t1 >= 1 then
    t1 = t1 - 1
    x2v = x2
    x2 = 0
    collectgarbage()
  end
  
  
  t2 = t2 + dt
  if t2 >= 0.1 then
    t2 = t2 - 0.1
    --g4()
    --g3()
  end
  
  
  if tr:peek('c2Data') ~= nil then
    imageD = tr:get('c2Data')
    if imageD then
      imageG = gr.newImage(imageD)
    end
  end
  
  if tr:get('c3Done') then 
    tr:set('c2',true) -- request imageD
    rdy = "done" 
  end
  
  --tr:set('c1',true) -- we want 'c1' every update
  
  local x
  x = tr:get("r1")
  if x ~= nil then
    x1 = x
  end
  
  
  if tr:peek('rt') then
   tt = tr:get('rt')
   --print(tt)
   str = TSerial.unpack(tt)
   --print(str)
  end
  
  
  if tr2:get('done2') then
    imageD2 = tr2:get('id2r')
    imageG2 = gr.newImage(imageD2) newPositionImageD2()
    local str= tr2:get('C2tabStr')
    C2tab = TSerial.unpack(str)
    C2TabImageD = buildTabImage(C2tab)
    imageTabG = gr.newImage(C2TabImageD)
  end
  
  if tr2:peek('id2rK')  then
    imageD2 = tr2:get('id2rK')
    imageG2 = gr.newImage(imageD2) newPositionImageD2()
  end
  
end
function love.draw()
  
  if toggleMe then
    gr.draw(imageMeG,0,0,0,0.3,0.3)
  end
  
  gr.draw(imageG2,Mbx,Mby) -- mandelbrot image
  
  
  ----------------------------------------------
  -- color table and escapeNumbers istogram
  ----------------------------------------------
  local xn
  for xn=0,MAXITER do
    gr.setPointSize(8) gr.setColor(250,250,250,250) gr.point(xn,104)
  end
  for xn=0,MAXITER do
    gr.setPointSize(4)
    gr.setColor(tabColor[xn][1],tabColor[xn][2],tabColor[xn][3],250)
    gr.point(xn,104)
  end
  gr.setColor(255,255,255,255)
  gr.setPointSize(1)
  gr.draw(imageTabG,0,0) --sh-imageTabG:getHeight())
  ----------------------------------------------
  
  
  --lastDrawTime = drawTime
  --drawTime = tm.getMicroTime()
  
  x2=x2+1
  x4=x4+1
  
  local aa,bb
  aa = sw/2  bb = sh/2
  --gr.draw(imageG,aa,bb,d3r,1,1,imageG:getWidth()/2,imageG:getHeight()/2)
  d3r = d3r + SpeedInc
  
  if not Clean then
  else
  end
  
  
  ---------------------------------------------
  if tr2:peek('nn') then
    vnn = tr2:get('nn')
  end
  if tr2:get('done') then
   ct = tr2:get('rest')
   ni = tr2:get('resv')
  end
  ----------------------------------------------
  
  
  ---------------------------------------------
  if tr2:peek('nn2') then
    vnn2 = tr2:get('nn2')
  end
  
  
  
  
  -----------------------------
  -- mandelbrot data
  -----------------------------
  
  keepMbPositions()
  
    local xa,ya
    xa = Mbx1 + Mbw * (mxc -mx1)/dxm   ya = Mby1 + Mbh * (myc -my1)/dxm
    gr.line(xa,Mby1,xa,Mby1-10)  gr.line(xa,Mby2,xa,Mby2+10)
    gr.line(Mbx1,ya,Mbx1-10,ya)  gr.line(Mbx2,ya,Mbx2+10,ya)
--  gr.line(mxw1,Mby1,mxw1,Mby1-10)  gr.line(mxw1,Mby2,mxw1,Mby2+10)
--  gr.line(mxw2,Mby1,mxw2,Mby1-10)  gr.line(mxw2,Mby2,mxw2,Mby2+10)
--  gr.line(Mbx1,myw1,Mbx1-10,myw1)  gr.line(Mbx2,myw1,Mbx2+10,myw1)
--  gr.line(Mbx1,myw2,Mbx1-10,myw2)  gr.line(Mbx2,myw2,Mbx2+10,myw2)
  
  
  if MShow then
    local mx,my
    mx,my = love.mouse.getPosition()
    if mx>Mbx1 and mx < Mbx2  and my>Mby1 and my<Mby2 then
      gr.line(mx,Mby1,mx,Mby2)
      gr.line(Mbx1,my,Mbx2,my)
      --gr.print("X",0,0)
    end
  end
  
  --gr.setFont(font14)
  gr.print("xc:"..mxc,0,sh-160)
  gr.print("yc:"..myc,0,sh-140)
  gr.print("xr:"..MbXratio,0,sh-120)
  gr.print("yr:"..MbYratio,0,sh-100)
  gr.print("n: "..vnn2,0,sh-80)  
  gr.print("d: "..math.abs(mx1-mx2),0,sh-60)  
  gr.print(mx1..","..mx2,0,sh-40)  
  gr.print(my1..","..my2,0,sh-20)  

  -----------------------------
    
  
  gr.draw(imageSG,100,200) -- ball test image
  
  --drawTime = tm.getMicroTime() - drawTime
  
  gr.print("h: toggle help",0,108)
  if drawHelpFlag then drawHelp(0,132,16)   end
  
end


function mapPixel_fillGreen(x,y,r,g,b,a)
  r = 0 g = 200 b = 0 a = 180
  return r,g,b,a
end
function fillRed(x,y,r,g,b,a)
  r = 200 g = 0 b = 0 a = 100
  return r,g,b,a
end
local x1,y1,x2,y2,angle,angleInc,radius,radiusInc
radius = 100 radiusInc = 0.01
angle = 0 angleInc = 0.01
x1=0 y1=0 x2=0 y2=0
function g4() -- draw something
  local x,y,r,g,b,a,mx,my
  r = 255 g = 255 b = 255 a = 255
  mx=imageD:getWidth()  my=imageD:getHeight() 
  local i,k,n  k = 50
  for i=0,k do
    radius = radius + radiusInc
    angle = angle + angleInc
    xa = radius * math.cos (angle)
    ya = radius * math.sin (angle)
    x2 = mx/2 + xa  y2 = my/2 + ya
    
    imageD:setPixel(x2,y2,r,g,b,255)

  end
end
function g3() -- add some random points
    local x,y,r,g,b,xh,yh,n,j,k
    xh = imageD:getWidth()/2
    yh = imageD:getHeight()/2
    for n=0,1 do
      x = xh - 255*math.random()
      y = yh - 255*math.random()
      r = 255*math.random()
      g = 255*math.random()
      b = 255*math.random()
      for j=0,3 do
        for k=0,3 do
          imageD:setPixel(x+k,y+j,r,g,b,255)
        end
      end
    end
end
keymodify = 0
Mxc=0 Myc = 0



function drawHelp(x,y,k)
local p=0
--gr.setFont(font14)
gr.print("escape: exit",x,y+p) p=p+k  
gr.print("0:who am i?",x,y+p) p=p+k

gr.print("1..9:stored Mandelbrot TAPs",x,y+p) p=p+k
gr.print("k:print image TAPs(x1,x2,y1,y2)",x,y+p) p=p+k

gr.print("kp1..6: Size 1..6 x100",x,y+p) p=p+k

gr.print("------------",x,y+p) p=p+k

gr.print("klik:prepare new center",x,y+p) p=p+k
gr.print("i:prepare zoom in",x,y+p) p=p+k
gr.print("o:prepare zoom out",x,y+p) p=p+k
gr.print("c:keep new center",x,y+p) p=p+k
gr.print("q:set window corners",x,y+p) p=p+k
gr.print("w:draw window",x,y+p) p=p+k
gr.print("m:draw mandelbrot",x,y+p) p=p+k
gr.print("x:stop draw",x,y+p) p=p+k
gr.print("s:save image",x,y+p) p=p+k
gr.print("------------",x,y+p) p=p+k

end



function love.keypressed(key)
  
  if key == 'escape' then
      love.event.quit()
  end
  
  if key == '0' then
    toggleMe = not toggleMe
  end
  
  if key >= '1' and key <='9' then
    local n = tonumber(key)
    keepTAP(n)
  end

  if key == 'k' then
    local str1=""
    str1 = "{"..mx1..","..mx2..","..my1..","..my2.."}"
    print(str1)
    print("saving TAP data...")
    local str2 = "TAP_"..os.time()..".txt"
    love.filesystem.write(str2,str1)
    print("saved.")
    
  end

  if key == 'kp1' then  tr2:set('size1',true)  end  
  if key == 'kp2' then  tr2:set('size2',true)  end  
  if key == 'kp3' then  tr2:set('size3',true)  end  
  if key == 'kp4' then  tr2:set('size4',true)  end  
  if key == 'kp5' then  tr2:set('size5',true)  end  
  if key == 'kp6' then  tr2:set('size6',true)  end  
    
  if key == 'm' then
    doMandel()
  end
  
  if key == 'x'then
    tr2:set('stop',true)
  end
  
  if key == 's' then
    tr2:set('saveData',true)
  end
  
  if key == '.'then  -- show cursor lines
    MShow = not MShow
  end
  
  if key == 'b' then -- draw ball
    local r,g,b,a  
    r=200 g=200 b=50 a=255
    draw_sphere (20, 4,0,r,g,b,a)
    imageSG = gr.newImage(imageSD)
  end
  
  if key == 'i' then -- zoom in
    dxm = dxm * 0.1
    if dxm < 4e-14 then dxm = 4e-14 end
    mx1 = mxc - dxm/2  mx2 = mxc + dxm/2
    my1 = myc - dxm/2  my2 = myc + dxm/2
  end
  
  if key == 'o' then --zoo out
    dxm = dxm * 10
    if dxm > 2 then dxm = 2 end
    mx1 = mxc - dxm/2  mx2 = mxc + dxm/2
    my1 = myc - dxm/2  my2 = myc + dxm/2
  end
  
  if key == 'c' then -- center image
    mx1 = mxc - dxm/2  mx2 = mxc + dxm/2
    my1 = myc - dxm/2  my2 = myc + dxm/2
  end
  
  if key == 'q'then  -- window zoom (first  window coordinates)
    --mxw1 = mxc  myw1 = myc
    mxw1 = mxw2  myw1 = myw2
    mxw2 = mxc  myw2 = myc
    end
  
  if key == 'w'then  -- window zoom (second window coordinates)
    --mxw1 = mxw2  myw1 = myw2
    --mxw2 = mxc  myw2 = myc
    if(mxw1==nil) or (myw1==nil) then return end
    local x1,y1,dx,dy
    
    x1 = math.min(mxw1,mxw2)
    y1 = math.min(myw1,myw2)
    dx = math.abs(mxw1-mxw2)
    dy = math.abs(myw1-myw2)
    dxm = math.max(dx,dy)
    
    if dxm < 4e-14 then dxm = 4e-14 end
    mxc = x1 + dx/2  myc = y1 + dy/2
    mx1 = mxc -dxm/2  mx2 = mxc + dxm/2
    my1 = myc -dxm/2  my2 = myc + dxm/2
    
    doMandel()
    
  end
  
  if key=='h' then
    drawHelpFlag = not drawHelpFlag
  end
end

function love.mousepressed()
  
  inside = keepMbPositions()
  
  if love.mouse.isDown("l") then
--    dxm = dxm * 0.1
--    if dxm < 4e-14 then dxm = 4e-14 end
--    mx1 = mxc - dxm/2  mx2 = mxc + dxm/2
--    my1 = myc - dxm/2  my2 = myc + dxm/2

    if inside then
      dxm = math.abs(mx1-mx2)
      dym = math.abs(my1-my2)
      mxc = mx1 + dxm * MbXratio
      myc = my1 + dym * MbYratio    
    end
    
  end
  
  if love.mouse.isDown("r") then
--    dxm = dxm * 10
--    if dxm > 2 then dxm = 2 end
--    mx1 = mxc - dxm/2  mx2 = mxc + dxm/2
--    my1 = myc - dxm/2  my2 = myc + dxm/2
  end
  --if inside then doMandel() end
end


function MbGlobals()  
  ------------------------------------------------------  
  --   some  used globals  for mandelbrot
  ------------------------------------------------------  
  z = complex.new(0,0)
  
  c = complex.new(0.001643721,0.82246763)
  
  nc = 1
  ncf = 0
  dist = 0
  
  mx1 = -2    mx2 = 0.5
  my1 = -1.25 my2 = 1.25
  
  dxm = math.abs(mx1-mx2)/2
  dym = math.abs(my1-my2)/2
  mxc = mx1 + dxm/2
  myc = my1 + dym/2
 
 
  Nx1=0 Nx2=0 Ny1=0 Ny2=0

  k11 = 1e-7
  km9 = 1e-11
  
  --doMandel()
end



TAP={
{-2,0.5,-1.25,1.25},  --{-2,2,-2,2},  -- {-2,0.5,-1.25,1.25},
{-1.36841527 , -1.36841477 , -0.01166799 , -0.01166749},
{0.4171375,0.4177625,-0.211625,-0.211	},
{-1.253574768227,-1.2535747681879,-0.022708294966489,-0.022708294927427	},
{-1.2535747682661,-1.2535747681684,-0.022708294997739,-0.022708294900084	},
{0.43517109375004,0.43526875000004,0.34146367187494,0.34156132812494	},
{-1.2535747683052,-1.2535747681097,-0.022708295044613,-0.022708294849303	},
{0.44323762154096,0.44323762154098,-0.23175904688112,-0.23175904688114	},
--{0.44323762154097,0.44323762154097,-0.23175904688113,-0.23175904688113	}
--{0.44323762716147,0.44323763340648,-0.23175905300123,-0.23175904675623	}
--{0.44323762833241,0.44323763223554,-0.23175905183029,-0.23175904792717	}
--{0.44323762983512,0.44323763003027,-0.2317590497226,-0.23175904952745	}
--{0.44323762871301,0.44323763115238,-0.23175905084471,-0.23175904840534	}
--[[

http://www.cygnus-software.com/gallery/bigimages/jewel_box.htm
center -1.367,964,148,94 +0.008,122,488,10 
]]
--{-1.36796414894-k11, -1.36796414894+k11, 0.00812248810-k11, 0.00812248810+k11}

--{-1.36796419494,-1.36796409494,0.0081224401,0.0081225401	}
--{-0.56688227124355-km9,-0.56688227124355+km9,-0.56439613649795-km9,-0.56439613649795+km9}
--{0.30110705636428,0.30110705636432,-0.020262469984143,-0.020262469984104	}
{-0.038449986831694,-0.038449986277548,0.98550807370098,0.98550807432136	}
}
KFirst = 0
function keepTAP(n)
  if TAP[n]==nil then return end
  mx1=TAP[n][1]mx2=TAP[n][2]my1=TAP[n][3]my2=TAP[n][4]
  if mx1==mx2 then mx1 = mx1 - 1e-14  mx2 = mx2+1e-14 end
  if my1==my2 then my1 = my1 - 1e-14  my2 = my2+1e-14 end
  dxm = math.abs(mx1-mx2)/2
  dym = math.abs(my1-my2)/2
  mxc = mx1 + dxm/2
  myc = my1 + dym/2
end


function doMandel()
    tr2:set('mx1',mx1)
    tr2:set('mx2',mx2)
    tr2:set('my1',my1)
    tr2:set('my2',my2)
    tr2:set('c2',true)
end


tabColor = {}
function buildColorsTab()
  local v,x,r,g,b,a,c,cn,F F = 5
  a=255
  for x=0,MAXITER do
    v = x/MAXITER -- v->0..1
    r = 128 + 127 * math.sin(3*math.pi/2 + 2*math.pi*F * v)
    g = 128 + 127 * math.sin(2*math.pi/2 + 2*math.pi*F * v)
    b = 128 + 127 * math.sin(1*math.pi/2 + 2*math.pi*F * v)
    tabColor[x]={r,g,b,a}
  end
  --tabColor[MAXITER]={0,0,0,0}
end

function buildColorsTab1()
  local x,r,g,b,a,c,cn
  a=255
  for x=0,MAXITER do
    r=0 g=0 b= 0
    if x < 256 then b = x 
    elseif x < 512 then b=255 g = x - 256 
    elseif x < 768 then b=255 g=255 r = x - 512
    else b=255 g=255 r = 255 end
    tabColor[x]={r,g,b,a}
  end
  --tabColor[MAXITER]={0,0,0,0}
end












function buildTabImage (tab)
  local imageD,n,i,v,k,x,y,max,min,r,g,b,a,idx
  print ("build table")
  k = MAXITER
  --n = #table
  imageD = im.newImageData(k,100+1)
  max = 0 min = 1000000
  for i=0,k do -- cerca il massimo
    if (max < tab[i]) then max = tab[i] idx = i end
    if (min > tab[i]) then min = tab[i] idx = i end
  end
  print ("max: "..max.." at "..idx)
  r=200 g=200 b=200 a = 240
  for i=1,k-1 do
    imageD:setPixel(i,100,255,155,0,a) -- base
    x = i  y = 100*tab[i]/max
    for j=1,y do
      imageD:setPixel(x,100-j,r,g,b,a) -- linea verticale
    end
  end
  return imageD
end


Buttons={}
function setButton(k,row,col,w,h,t)
  local x1,y1,w1,h1,r,g,b,a,pw
  x1=row*k y1=col*k w1=w*k h1=h*k
  table.insert(Buttons,{x1,y1,x1+w1,y1+h1,t})
end
C2tab={}  
MAXITER = 256*3
function newPositionImageD2()
  Mbw = imageD2:getWidth()
  Mbh = imageD2:getHeight()
  Mbx = 1/2*sw - Mbw/2
  Mby = 1/2*sh - Mbh/2
  Mbx1 = Mbx  Mbx2 = Mbx+Mbw  
  Mby1 = Mby  Mby2 = Mby+Mbh  
  MbXratio = 1
  MbYratio = 1
  keepMbPositions()
end


--MousePress1 = false
--MousePress2 = false
function keepMbPositions()
  local x,y
  x,y = love.mouse.getPosition()
  if x>Mbx1 and x<Mbx2 and y>Mby1 and y<Mby2 then
    inside = true
    MbXratio = (x-Mbx1)/Mbw    
    MbYratio = (y-Mby1)/Mbh
--    dxm = math.abs(mx1-mx2)
--    dym = math.abs(my1-my2)
--    mxc = mx1 + dxm * MbXratio
--    myc = my1 + dym * MbYratio
  else
    inside = false
  end
  return inside
end